"use strict";
//@ts-ignore
var MutableBlockPos = Java.type("net.minecraft.util.BlockPos.MutableBlockPos");
//@ts-ignore
var script = registerScript({
    name: "Benchmark",
    version: "0.1",
    authors: ["mumy++"]
});
var Fibonacci = /** @class */ (function () {
    function Fibonacci() {
    }
    Fibonacci.fibonacci = function (n) {
        if (n < 3) {
            return 1;
        }
        return this.fibonacci(n - 2) + this.fibonacci(n - 1);
    };
    Fibonacci.test = function () {
        for (var i = 0; i < 50; ++i) {
            this.fibonacci(16);
        }
        var start = new Date().getTime();
        var value = this.fibonacci(38);
        var time = new Date().getTime() - start;
        return { name: "Fibonacci", time: time, value: value };
    };
    return Fibonacci;
}());
var SieveEratosphen = /** @class */ (function () {
    function SieveEratosphen() {
    }
    SieveEratosphen.sieveEratosphen = function (n) {
        if (n <= 2) {
            return null;
        }
        var numbers = new Array(n);
        for (var i = 0; i < numbers.length; ++i) {
            numbers[i] = true;
        }
        var next = 2;
        while (next * next <= n) {
            if (numbers[next]) {
                for (var i = 0; i < n - next; ++i) {
                    var step = next * next + i * next;
                    if (step < n) {
                        numbers[step] = false;
                    }
                    else {
                        break;
                    }
                }
            }
            ++next;
        }
        var maximum = 0;
        for (var i = 2; i < numbers.length; i++) {
            if (numbers[i]) {
                maximum = i;
            }
        }
        return maximum;
    };
    SieveEratosphen.test = function () {
        for (var i = 0; i < 50; ++i) {
            this.sieveEratosphen(1000);
        }
        var start = new Date().getTime();
        var value = this.sieveEratosphen(50000000);
        var time = new Date().getTime() - start;
        return { name: "SieveEratosphen", time: time, value: value };
    };
    return SieveEratosphen;
}());
var WorldScanner = /** @class */ (function () {
    function WorldScanner() {
    }
    WorldScanner.scan = function () {
        var blocks = [];
        var blockPos = new MutableBlockPos();
        for (var x = -100; x <= 100; ++x) {
            for (var z = -100; z <= 100; ++z) {
                for (var y = 0; y <= 254; ++y) {
                    //@ts-ignore
                    blocks.push(mc.theWorld.func_180495_p(blockPos.func_181079_c(x, y, z)));
                }
            }
        }
        return blocks.length;
    };
    WorldScanner.test = function () {
        for (var i = 0; i < 5; ++i) {
            this.scan();
        }
        var start = new Date().getTime();
        var value = this.scan();
        var time = new Date().getTime() - start;
        return { name: "WorldScanner", time: time, value: value };
    };
    return WorldScanner;
}());
script.registerModule({
    name: "Benchmark",
    category: "Misc",
    description: "A module designed for performance benchmarking, showcasing the power of LiquidBounce's script API."
}, function (mod) {
    mod.on("enable", function () {
        var results = [Fibonacci.test(), SieveEratosphen.test(), WorldScanner.test()];
        results.forEach(function (it) {
            //@ts-ignore
            Chat.print("".concat(it.name, " [time: ").concat(it.time, "ms, value: ").concat(it.value, "]"));
        });
    });
});
