"use strict";
//@ts-ignore
const MutableBlockPos = Java.type("net.minecraft.util.math.BlockPos.Mutable");
//@ts-ignore
const script = registerScript({
    name: "Benchmark",
    version: "0.1",
    authors: ["mumy++"]
});
class Fibonacci {
    static fibonacci(n) {
        if (n < 3) {
            return 1;
        }
        return this.fibonacci(n - 2) + this.fibonacci(n - 1);
    }
    static test() {
        for (let i = 0; i < 50; ++i) {
            this.fibonacci(16);
        }
        const start = new Date().getTime();
        const value = this.fibonacci(38);
        const time = new Date().getTime() - start;
        return { name: "Fibonacci", time, value };
    }
}
class SieveEratosphen {
    static sieveEratosphen(n) {
        if (n <= 2) {
            return null;
        }
        const numbers = new Array(n);
        for (let i = 0; i < numbers.length; ++i) {
            numbers[i] = true;
        }
        let next = 2;
        while (next * next <= n) {
            if (numbers[next]) {
                for (let i = 0; i < n - next; ++i) {
                    const step = next * next + i * next;
                    if (step < n) {
                        numbers[step] = false;
                    }
                    else {
                        break;
                    }
                }
            }
            ++next;
        }
        let maximum = 0;
        for (let i = 2; i < numbers.length; i++) {
            if (numbers[i]) {
                maximum = i;
            }
        }
        return maximum;
    }
    static test() {
        for (let i = 0; i < 50; ++i) {
            this.sieveEratosphen(1000);
        }
        const start = new Date().getTime();
        const value = this.sieveEratosphen(50000000);
        const time = new Date().getTime() - start;
        return { name: "SieveEratosphen", time, value };
    }
}
class WorldScanner {
    static scan() {
        const blocks = [];
        const blockPos = new MutableBlockPos();
        for (let x = -100; x <= 100; ++x) {
            for (let z = -100; z <= 100; ++z) {
                for (let y = 0; y <= 254; ++y) {
                    //@ts-ignore
                    blocks.push(mc.world.getBlockState(blockPos.set(x, y, z)));
                }
            }
        }
        return blocks.length;
    }
    static test() {
        for (let i = 0; i < 5; ++i) {
            this.scan();
        }
        const start = new Date().getTime();
        const value = this.scan();
        const time = new Date().getTime() - start;
        return { name: "WorldScanner", time, value };
    }
}
script.registerModule({
    name: "Benchmark",
    category: "Misc",
    description: "A module designed for performance benchmarking, showcasing the power of LiquidBounce's script API."
}, (mod) => {
    mod.on("enable", () => {
        const results = [Fibonacci.test(), SieveEratosphen.test(), WorldScanner.test()];
        results.forEach((it) => {
            //@ts-ignore
            Client.displayChatMessage(`${it.name} [time: ${it.time}ms, value: ${it.value}]`);
        });
    });
});
